open Ast

type sformal =
  SFormal of Ast.var_type * string

type svar_decl =
    SVar of Ast.var_type * string
  | SVar_Decl_Assign of Ast.var_type * string * sexpr

and sexpr =
    SLiteral of sliteral * Ast.var_type
  | SId of string * Ast.var_type
  | SBinop of sexpr * Ast.op * sexpr * Ast.var_type
  | SAssign of string * sexpr * Ast.var_type
  | SUnop of Ast.unop * sexpr * Ast.var_type
  | SCall of string * sexpr list * Ast.var_type
  | SLi_list of sexpr list * Ast.var_type
  | SLi_list_ref of string * expr * Ast.var_type
  | SNoexpr

and sliteral =
  SInt_Literal of int
  | SDouble_Literal of float
  | SString_Literal of string
  | SBool_Literal of bool

and sstatement =
  SBlock of sstatement list
  | SExpr of sexpr
  | SReturn of sexpr
  | SIf of sexpr * sstatement * sstatement
  | SLoop of sexpr * sexpr * sexpr * sstatement
  | SVar_Decl of svar_decl

type sfunc_decl = {
  sfname : string;
  sformals : sformal list;
  sbody : sstatement list;
  sreturn_type : Ast.var_type;
}

type sprogram =
  SProg of svar_decl list * sfunc_decl list